<template>
  <section-container title="Vault">
    <api-data endpoint="/vault/" v-model="vaultItems" ref="vaultLoader" />
    <ul class="nav nav-tabs">
      <li class="nav-item">
        <a
          href="/vault/project"
          :class="`nav-link ${currentTab == 'project' ? 'active' : ''}`"
          @click.prevent="selectTab('project')"
          >Project Credentials</a
        >
      </li>
      <li class="nav-item">
        <a
          href="/vault/sandbox"
          :class="`nav-link ${currentTab == 'sandbox' ? 'active' : ''}`"
          @click.prevent="selectTab('sandbox')"
          >Sandbox &amp; Datamarts</a
        >
      </li>
      <li class="nav-item">
        <a
          href="/vault/special"
          :class="`nav-link ${currentTab == 'special' ? 'active' : ''}`"
          @click.prevent="selectTab('special')"
          >Special Credentials</a
        >
      </li>
      <li class="last-child-pull">
        <a
          :href="`/vault/${this.currentTab}/${generateUniqueName()}`"
          class="btn btn-primary"
          @click.prevent="showDetails(generateUniqueName())"
          ><i class="fas fa-plus"></i> Create new...</a
        >
      </li>
    </ul>
    <div class="input-group mt-3">
      <div class="input-group-text">
        <button type="button" class="btn" @click="vaultFilter = ''">
          <i class="fas fa-times"></i>
        </button>
      </div>
      <input
        type="text"
        name="vault-filter"
        id="vault-filter"
        class="form-control"
        v-model="vaultFilter"
        placeholder="Filter vault credentials"
      />
    </div>
    <table
      class="table vault tab-content mt-3"
      v-if="vaultItemsFiltered.length > 0"
    >
      <thead>
        <tr>
          <th>ID</th>
          <th>Type</th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="item in vaultItemsFiltered"
          :key="item.id"
          @click="showDetails(item.id)"
        >
          <td>
            <a :href="`/vault/${currentTab}/${item.id}`" @click.prevent>{{
              item.id
            }}</a>
          </td>
          <td>
            <i
              :class="getVaultItemConfig(item.type).icon"
              :title="item.type"
            ></i
            >&nbsp;<span class="d-none d-sm-inline">{{ item.type }}</span>
          </td>
        </tr>
      </tbody>
    </table>
    <div class="tab-content mt-3" v-else>
      <p>No credentials found for given filters</p>
    </div>
    <transition name="fade">
      <credentials-details
        :key="`${displayDetails}-${counter}`"
        :credential-id="displayDetails"
        v-if="displayDetails !== null"
        @close="detailsClosed"
        :existing="vaultItemIds"
      />
    </transition>
  </section-container>
</template>

<script>
import CredentialsDetails from "@/components/CredentialsDetails";
const { getVaultItemConfig } = require("@/helpers/constants.js");

const typeFilter = {
  project: ["credentials"],
  sandbox: ["sandbox", "datamart", "share"],
  special: ["storage", "other"],
};

export default {
  name: "Vault",
  components: { CredentialsDetails },
  data() {
    const currentTab = this.$route.params.type || "project";
    const displayDetails = this.$route.params.item || null;
    return {
      vaultItems: [],
      displayDetails,
      counter: 0,
      currentTab,
      vaultFilter: "",
    };
  },
  inject: ["toggleProgressSpinner"],
  provide() {
    return {
      saveCredentials: this.saveCredentials,
    };
  },
  methods: {
    loadVault() {
      this.$refs.vaultLoader.load();
    },
    saveCredentials({ id, value }) {
      this.toggleProgressSpinner(true);
      const url = `${this.apiUrl}/vault/`;
      import("axios").then(({ default: axios }) => {
        axios
          .post(url, { value, id }, { withCredentials: true })
          .then(() => {
            this.notify(
              "Credentials were saved successfully",
              "Vault updated",
              "success"
            );
          })
          .catch((error) => {
            this.notify(error, error.name, "error");
          })
          .finally(() => {
            this.toggleProgressSpinner(false);
            this.loadVault();
            this.pushState("vault", [this.currentTab], "Vault");
          });
      });
    },
    generateUniqueName() {
      let i = 1;
      while (
        this.vaultItems.filter((cred) => cred.id === `new-credentials-${i}`)
          .length > 0
      ) {
        i += 1;
      }
      return `new-credentials-${i}`;
    },
    selectTab(tabname) {
      this.currentTab = tabname;
      this.pushState("vault", [tabname]);
    },
    getVaultItemConfig,
    detailsClosed() {
      this.counter++;
      this.displayDetails = null;
      this.pushState("vault", [this.currentTab]);
    },
    showDetails(item) {
      this.displayDetails = item;
      this.pushState("vault", [this.currentTab, item]);
    },
  },
  computed: {
    vaultItemsFiltered: {
      get() {
        return this.vaultItems.filter((item) => {
          const clean = item.id.toLowerCase();
          const searchTerm = this.vaultFilter.toLowerCase();
          return (
            (typeFilter[this.currentTab] || []).includes(item.type) &&
            (searchTerm.length > 0 ? clean.indexOf(searchTerm) !== -1 : true)
          );
        });
      },
    },
    vaultItemIds() {
      return this.vaultItems.map((el) => el.id);
    },
  },
};
</script>

<style lang="scss">
table.vault {
  tr:hover {
    background: rgba(0, 0, 0, 0.3);
    cursor: pointer;
  }
}
</style>
